<?php

namespace Portfolio\Configure\Database;

use PDO;

class Connection
{
    private $databaseName;
    private $databaseHost;
    private $databaseUsername;
    private $databasePassword;
    private $databasePdo;

    public function __construct(string $databaseName, string $databaseHost, string $databaseUsername, string $databasePassword)
    {
        $this->databaseName = $databaseName;
        $this->databaseHost = $databaseHost;
        $this->databaseUsername = $databaseUsername;
        $this->databasePassword = $databasePassword;
    }

    public function get_pdo(): PDO
    {
        if ($this->databasePdo === null) {
            $this->databasePdo = new PDO(
                "pgsql:host=localhost;port=5433;dbname=portfolio",
                $this->databaseUsername,
                $this->databasePassword,
                [
                    PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION,
                    PDO::ATTR_DEFAULT_FETCH_MODE => PDO::FETCH_OBJ,
                ]
            );
            $this->databasePdo->exec("SET client_encoding TO 'utf8'");
        }

        return $this->databasePdo;
    }
}