<?php

namespace Portfolio\Configure\Routing;

use Portfolio\Configure\Database\Connection;

class Route
{
    public $path;
    public $action;
    public $matches;

    public function __construct($path, $action)
    {
        $this->path = trim($path, '/');
        $this->action = $action;
    }

    public function matches(string $url)
    {
        $path = preg_replace('#:([\w]+)#', '([^/]+)', $this->path);
        $pathToMatch = "#^$path$#";

        if (!preg_match($pathToMatch, $url, $matches)) {
            return false;
        }

        $this->matches = $matches;
        return true;
    }

    public function execute()
    {
        $params = explode('@', $this->action);
        $controller = new $params[0](
            new Connection('portfolio',
                '127.0.0.1',
                'postgres',
                'postgres')
        );
        $method = $params[1];

        if (isset($this->matches[1])) {
            return $controller->$method($this->matches[1]);
        }

        return $controller->$method();
    }
}