document.addEventListener("DOMContentLoaded", () => {
    const menuToggle = document.getElementById("menu-toggle");
    const navbar = document.getElementById("navbar");
    const themeToggle = document.getElementById("theme-toggle");
    const body = document.body;

    // Menu burger
    menuToggle.addEventListener("click", () => {
        navbar.classList.toggle("active");
        const isExpanded = navbar.classList.contains("active");
        menuToggle.setAttribute("aria-expanded", isExpanded.toString());
    });

    // Appliquer le thème sauvegardé
    const savedTheme = localStorage.getItem("theme") || "light";
    body.classList.add(`${savedTheme}-theme`);
    themeToggle.checked = savedTheme === "dark";

    // Toggle de thème
    themeToggle.addEventListener("change", () => {
        const isDark = themeToggle.checked;
        body.classList.toggle("dark-theme", isDark);
        body.classList.toggle("light-theme", !isDark);
        localStorage.setItem("theme", isDark ? "dark" : "light");
    });
});
